﻿#pragma warning disable 1591
//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Data
{
	using System.Data.Linq;
	using System.Data.Linq.Mapping;
	using System.Data;
	using System.Collections.Generic;
	using System.Reflection;
	using System.Linq;
	using System.Linq.Expressions;
	using System.ComponentModel;
	using System;
	
	
	[global::System.Data.Linq.Mapping.DatabaseAttribute(Name="DORA_DB")]
	public partial class DORA_DBDataContext : System.Data.Linq.DataContext
	{
		
		private static System.Data.Linq.Mapping.MappingSource mappingSource = new AttributeMappingSource();
		
    #region Extensibility Method Definitions
    partial void OnCreated();
    partial void InsertUtilizador_Ponto(Utilizador_Ponto instance);
    partial void UpdateUtilizador_Ponto(Utilizador_Ponto instance);
    partial void DeleteUtilizador_Ponto(Utilizador_Ponto instance);
    partial void InsertUtilizador(Utilizador instance);
    partial void UpdateUtilizador(Utilizador instance);
    partial void DeleteUtilizador(Utilizador instance);
    partial void InsertSessao(Sessao instance);
    partial void UpdateSessao(Sessao instance);
    partial void DeleteSessao(Sessao instance);
    partial void InsertPonto_Sessao(Ponto_Sessao instance);
    partial void UpdatePonto_Sessao(Ponto_Sessao instance);
    partial void DeletePonto_Sessao(Ponto_Sessao instance);
    partial void InsertFoto(Foto instance);
    partial void UpdateFoto(Foto instance);
    partial void DeleteFoto(Foto instance);
    partial void InsertPonto(Ponto instance);
    partial void UpdatePonto(Ponto instance);
    partial void DeletePonto(Ponto instance);
    #endregion
		
		public DORA_DBDataContext() : 
				base(global::DORA_Manager.Properties.Settings.Default.DORA_DBConnectionString, mappingSource)
		{
			OnCreated();
		}
		
		public DORA_DBDataContext(string connection) : 
				base(connection, mappingSource)
		{
			OnCreated();
		}
		
		public DORA_DBDataContext(System.Data.IDbConnection connection) : 
				base(connection, mappingSource)
		{
			OnCreated();
		}
		
		public DORA_DBDataContext(string connection, System.Data.Linq.Mapping.MappingSource mappingSource) : 
				base(connection, mappingSource)
		{
			OnCreated();
		}
		
		public DORA_DBDataContext(System.Data.IDbConnection connection, System.Data.Linq.Mapping.MappingSource mappingSource) : 
				base(connection, mappingSource)
		{
			OnCreated();
		}
		
		public System.Data.Linq.Table<Utilizador_Ponto> Utilizador_Pontos
		{
			get
			{
				return this.GetTable<Utilizador_Ponto>();
			}
		}
		
		public System.Data.Linq.Table<Utilizador> Utilizadors
		{
			get
			{
				return this.GetTable<Utilizador>();
			}
		}
		
		public System.Data.Linq.Table<Sessao> Sessaos
		{
			get
			{
				return this.GetTable<Sessao>();
			}
		}
		
		public System.Data.Linq.Table<Ponto_Sessao> Ponto_Sessaos
		{
			get
			{
				return this.GetTable<Ponto_Sessao>();
			}
		}
		
		public System.Data.Linq.Table<Foto> Fotos
		{
			get
			{
				return this.GetTable<Foto>();
			}
		}
		
		public System.Data.Linq.Table<Ponto> Pontos
		{
			get
			{
				return this.GetTable<Ponto>();
			}
		}
		
		public System.Data.Linq.Table<melhor_explorador> melhor_exploradors
		{
			get
			{
				return this.GetTable<melhor_explorador>();
			}
		}
		
		[global::System.Data.Linq.Mapping.FunctionAttribute(Name="dbo.adicionar_pontos")]
		public int adicionar_pontos([global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(31)")] string user, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(11)")] string sessao, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(MAX)")] string latitudes, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(MAX)")] string longitudes, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(MAX)")] string nomes, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(MAX)")] string descricoes)
		{
			IExecuteResult result = this.ExecuteMethodCall(this, ((MethodInfo)(MethodInfo.GetCurrentMethod())), user, sessao, latitudes, longitudes, nomes, descricoes);
			return ((int)(result.ReturnValue));
		}
		
		[global::System.Data.Linq.Mapping.FunctionAttribute(Name="dbo.adicionar_sessao")]
		public int adicionar_sessao([global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(11)")] string codigo, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="Int")] System.Nullable<int> pontuacao, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="Date")] System.Nullable<System.DateTime> data, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="VarBinary(MAX)")] System.Data.Linq.Binary voz, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(MAX)")] string relatorio, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(31)")] string user, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(MAX)")] string latitudes, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(MAX)")] string longitudes, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(MAX)")] string nomes, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(MAX)")] string descricoes, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="NVarChar(MAX)")] string fotos, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="Float")] System.Nullable<double> distance)
		{
			IExecuteResult result = this.ExecuteMethodCall(this, ((MethodInfo)(MethodInfo.GetCurrentMethod())), codigo, pontuacao, data, voz, relatorio, user, latitudes, longitudes, nomes, descricoes, fotos, distance);
			return ((int)(result.ReturnValue));
		}
		
		[global::System.Data.Linq.Mapping.FunctionAttribute(Name="dbo.fotos_local")]
		public ISingleResult<fotos_localResult> fotos_local([global::System.Data.Linq.Mapping.ParameterAttribute(DbType="Float")] System.Nullable<double> latitude, [global::System.Data.Linq.Mapping.ParameterAttribute(DbType="Float")] System.Nullable<double> longitude)
		{
			IExecuteResult result = this.ExecuteMethodCall(this, ((MethodInfo)(MethodInfo.GetCurrentMethod())), latitude, longitude);
			return ((ISingleResult<fotos_localResult>)(result.ReturnValue));
		}
		
		[global::System.Data.Linq.Mapping.FunctionAttribute(Name="dbo.local_mais_visitado")]
		public ISingleResult<local_mais_visitadoResult> local_mais_visitado()
		{
			IExecuteResult result = this.ExecuteMethodCall(this, ((MethodInfo)(MethodInfo.GetCurrentMethod())));
			return ((ISingleResult<local_mais_visitadoResult>)(result.ReturnValue));
		}
		
		[global::System.Data.Linq.Mapping.FunctionAttribute(Name="dbo.quadro_pontuacoes")]
		public ISingleResult<quadro_pontuacoesResult> quadro_pontuacoes()
		{
			IExecuteResult result = this.ExecuteMethodCall(this, ((MethodInfo)(MethodInfo.GetCurrentMethod())));
			return ((ISingleResult<quadro_pontuacoesResult>)(result.ReturnValue));
		}
		
		[global::System.Data.Linq.Mapping.FunctionAttribute(Name="dbo.Split", IsComposable=true)]
		public IQueryable<SplitResult> Split([global::System.Data.Linq.Mapping.ParameterAttribute(Name="InputString", DbType="NVarChar(MAX)")] string inputString, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="Delimiter", DbType="NVarChar(50)")] string delimiter)
		{
			return this.CreateMethodCallQuery<SplitResult>(this, ((MethodInfo)(MethodInfo.GetCurrentMethod())), inputString, delimiter);
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.Utilizador_Ponto")]
	public partial class Utilizador_Ponto : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private string _Utilizadoremail;
		
		private double _Pontolatitude;
		
		private double _Pontolongitude;
		
		private string _nome_do_local;
		
		private string _descricao;
		
		private bool _primeiro;
		
		private EntitySet<Foto> _Fotos;
		
		private EntityRef<Utilizador> _Utilizador;
		
		private EntityRef<Ponto> _Ponto;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnUtilizadoremailChanging(string value);
    partial void OnUtilizadoremailChanged();
    partial void OnPontolatitudeChanging(double value);
    partial void OnPontolatitudeChanged();
    partial void OnPontolongitudeChanging(double value);
    partial void OnPontolongitudeChanged();
    partial void Onnome_do_localChanging(string value);
    partial void Onnome_do_localChanged();
    partial void OndescricaoChanging(string value);
    partial void OndescricaoChanged();
    partial void OnprimeiroChanging(bool value);
    partial void OnprimeiroChanged();
    #endregion
		
		public Utilizador_Ponto()
		{
			this._Fotos = new EntitySet<Foto>(new Action<Foto>(this.attach_Fotos), new Action<Foto>(this.detach_Fotos));
			this._Utilizador = default(EntityRef<Utilizador>);
			this._Ponto = default(EntityRef<Ponto>);
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Utilizadoremail", DbType="NVarChar(50) NOT NULL", CanBeNull=false, IsPrimaryKey=true)]
		public string Utilizadoremail
		{
			get
			{
				return this._Utilizadoremail;
			}
			set
			{
				if ((this._Utilizadoremail != value))
				{
					if (this._Utilizador.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnUtilizadoremailChanging(value);
					this.SendPropertyChanging();
					this._Utilizadoremail = value;
					this.SendPropertyChanged("Utilizadoremail");
					this.OnUtilizadoremailChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Pontolatitude", DbType="Float NOT NULL", IsPrimaryKey=true)]
		public double Pontolatitude
		{
			get
			{
				return this._Pontolatitude;
			}
			set
			{
				if ((this._Pontolatitude != value))
				{
					if (this._Ponto.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnPontolatitudeChanging(value);
					this.SendPropertyChanging();
					this._Pontolatitude = value;
					this.SendPropertyChanged("Pontolatitude");
					this.OnPontolatitudeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Pontolongitude", DbType="Float NOT NULL", IsPrimaryKey=true)]
		public double Pontolongitude
		{
			get
			{
				return this._Pontolongitude;
			}
			set
			{
				if ((this._Pontolongitude != value))
				{
					if (this._Ponto.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnPontolongitudeChanging(value);
					this.SendPropertyChanging();
					this._Pontolongitude = value;
					this.SendPropertyChanged("Pontolongitude");
					this.OnPontolongitudeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_nome_do_local", DbType="NVarChar(100)")]
		public string nome_do_local
		{
			get
			{
				return this._nome_do_local;
			}
			set
			{
				if ((this._nome_do_local != value))
				{
					this.Onnome_do_localChanging(value);
					this.SendPropertyChanging();
					this._nome_do_local = value;
					this.SendPropertyChanged("nome_do_local");
					this.Onnome_do_localChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_descricao", DbType="NVarChar(MAX)")]
		public string descricao
		{
			get
			{
				return this._descricao;
			}
			set
			{
				if ((this._descricao != value))
				{
					this.OndescricaoChanging(value);
					this.SendPropertyChanging();
					this._descricao = value;
					this.SendPropertyChanged("descricao");
					this.OndescricaoChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_primeiro", DbType="Bit NOT NULL")]
		public bool primeiro
		{
			get
			{
				return this._primeiro;
			}
			set
			{
				if ((this._primeiro != value))
				{
					this.OnprimeiroChanging(value);
					this.SendPropertyChanging();
					this._primeiro = value;
					this.SendPropertyChanged("primeiro");
					this.OnprimeiroChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Utilizador_Ponto_Foto", Storage="_Fotos", ThisKey="Utilizadoremail,Pontolatitude,Pontolongitude", OtherKey="email,latitude,longitude")]
		public EntitySet<Foto> Fotos
		{
			get
			{
				return this._Fotos;
			}
			set
			{
				this._Fotos.Assign(value);
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Utilizador_Utilizador_Ponto", Storage="_Utilizador", ThisKey="Utilizadoremail", OtherKey="email", IsForeignKey=true)]
		public Utilizador Utilizador
		{
			get
			{
				return this._Utilizador.Entity;
			}
			set
			{
				Utilizador previousValue = this._Utilizador.Entity;
				if (((previousValue != value) 
							|| (this._Utilizador.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._Utilizador.Entity = null;
						previousValue.Utilizador_Pontos.Remove(this);
					}
					this._Utilizador.Entity = value;
					if ((value != null))
					{
						value.Utilizador_Pontos.Add(this);
						this._Utilizadoremail = value.email;
					}
					else
					{
						this._Utilizadoremail = default(string);
					}
					this.SendPropertyChanged("Utilizador");
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Ponto_Utilizador_Ponto", Storage="_Ponto", ThisKey="Pontolatitude,Pontolongitude", OtherKey="latitude,longitude", IsForeignKey=true)]
		public Ponto Ponto
		{
			get
			{
				return this._Ponto.Entity;
			}
			set
			{
				Ponto previousValue = this._Ponto.Entity;
				if (((previousValue != value) 
							|| (this._Ponto.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._Ponto.Entity = null;
						previousValue.Utilizador_Pontos.Remove(this);
					}
					this._Ponto.Entity = value;
					if ((value != null))
					{
						value.Utilizador_Pontos.Add(this);
						this._Pontolatitude = value.latitude;
						this._Pontolongitude = value.longitude;
					}
					else
					{
						this._Pontolatitude = default(double);
						this._Pontolongitude = default(double);
					}
					this.SendPropertyChanged("Ponto");
				}
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
		
		private void attach_Fotos(Foto entity)
		{
			this.SendPropertyChanging();
			entity.Utilizador_Ponto = this;
		}
		
		private void detach_Fotos(Foto entity)
		{
			this.SendPropertyChanging();
			entity.Utilizador_Ponto = null;
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.Utilizador")]
	public partial class Utilizador : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private string _email;
		
		private string _telefone;
		
		private string _facebook;
		
		private string _password;
		
		private System.DateTime _data_nascimento;
		
		private string _nome;
		
		private string _rua;
		
		private string _localidade;
		
		private double _latitude;
		
		private double _longitude;
		
		private string _ranking;
		
		private System.Data.Linq.Binary _imagem_de_perfil;
		
		private int _pontuacao_geral;
		
		private bool _logged_in;
		
		private EntitySet<Utilizador_Ponto> _Utilizador_Pontos;
		
		private EntitySet<Sessao> _Sessaos;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnemailChanging(string value);
    partial void OnemailChanged();
    partial void OntelefoneChanging(string value);
    partial void OntelefoneChanged();
    partial void OnfacebookChanging(string value);
    partial void OnfacebookChanged();
    partial void OnpasswordChanging(string value);
    partial void OnpasswordChanged();
    partial void Ondata_nascimentoChanging(System.DateTime value);
    partial void Ondata_nascimentoChanged();
    partial void OnnomeChanging(string value);
    partial void OnnomeChanged();
    partial void OnruaChanging(string value);
    partial void OnruaChanged();
    partial void OnlocalidadeChanging(string value);
    partial void OnlocalidadeChanged();
    partial void OnlatitudeChanging(double value);
    partial void OnlatitudeChanged();
    partial void OnlongitudeChanging(double value);
    partial void OnlongitudeChanged();
    partial void OnrankingChanging(string value);
    partial void OnrankingChanged();
    partial void Onimagem_de_perfilChanging(System.Data.Linq.Binary value);
    partial void Onimagem_de_perfilChanged();
    partial void Onpontuacao_geralChanging(int value);
    partial void Onpontuacao_geralChanged();
    partial void Onlogged_inChanging(bool value);
    partial void Onlogged_inChanged();
    #endregion
		
		public Utilizador()
		{
			this._Utilizador_Pontos = new EntitySet<Utilizador_Ponto>(new Action<Utilizador_Ponto>(this.attach_Utilizador_Pontos), new Action<Utilizador_Ponto>(this.detach_Utilizador_Pontos));
			this._Sessaos = new EntitySet<Sessao>(new Action<Sessao>(this.attach_Sessaos), new Action<Sessao>(this.detach_Sessaos));
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_email", DbType="NVarChar(50) NOT NULL", CanBeNull=false, IsPrimaryKey=true)]
		public string email
		{
			get
			{
				return this._email;
			}
			set
			{
				if ((this._email != value))
				{
					this.OnemailChanging(value);
					this.SendPropertyChanging();
					this._email = value;
					this.SendPropertyChanged("email");
					this.OnemailChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_telefone", DbType="NVarChar(11)")]
		public string telefone
		{
			get
			{
				return this._telefone;
			}
			set
			{
				if ((this._telefone != value))
				{
					this.OntelefoneChanging(value);
					this.SendPropertyChanging();
					this._telefone = value;
					this.SendPropertyChanged("telefone");
					this.OntelefoneChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_facebook", DbType="NVarChar(100)")]
		public string facebook
		{
			get
			{
				return this._facebook;
			}
			set
			{
				if ((this._facebook != value))
				{
					this.OnfacebookChanging(value);
					this.SendPropertyChanging();
					this._facebook = value;
					this.SendPropertyChanged("facebook");
					this.OnfacebookChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_password", DbType="NVarChar(32) NOT NULL", CanBeNull=false)]
		public string password
		{
			get
			{
				return this._password;
			}
			set
			{
				if ((this._password != value))
				{
					this.OnpasswordChanging(value);
					this.SendPropertyChanging();
					this._password = value;
					this.SendPropertyChanged("password");
					this.OnpasswordChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_data_nascimento", DbType="Date NOT NULL")]
		public System.DateTime data_nascimento
		{
			get
			{
				return this._data_nascimento;
			}
			set
			{
				if ((this._data_nascimento != value))
				{
					this.Ondata_nascimentoChanging(value);
					this.SendPropertyChanging();
					this._data_nascimento = value;
					this.SendPropertyChanged("data_nascimento");
					this.Ondata_nascimentoChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_nome", DbType="NVarChar(100) NOT NULL", CanBeNull=false)]
		public string nome
		{
			get
			{
				return this._nome;
			}
			set
			{
				if ((this._nome != value))
				{
					this.OnnomeChanging(value);
					this.SendPropertyChanging();
					this._nome = value;
					this.SendPropertyChanged("nome");
					this.OnnomeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_rua", DbType="NVarChar(100) NOT NULL", CanBeNull=false)]
		public string rua
		{
			get
			{
				return this._rua;
			}
			set
			{
				if ((this._rua != value))
				{
					this.OnruaChanging(value);
					this.SendPropertyChanging();
					this._rua = value;
					this.SendPropertyChanged("rua");
					this.OnruaChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_localidade", DbType="NVarChar(100) NOT NULL", CanBeNull=false)]
		public string localidade
		{
			get
			{
				return this._localidade;
			}
			set
			{
				if ((this._localidade != value))
				{
					this.OnlocalidadeChanging(value);
					this.SendPropertyChanging();
					this._localidade = value;
					this.SendPropertyChanged("localidade");
					this.OnlocalidadeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_latitude", DbType="Float NOT NULL")]
		public double latitude
		{
			get
			{
				return this._latitude;
			}
			set
			{
				if ((this._latitude != value))
				{
					this.OnlatitudeChanging(value);
					this.SendPropertyChanging();
					this._latitude = value;
					this.SendPropertyChanged("latitude");
					this.OnlatitudeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_longitude", DbType="Float NOT NULL")]
		public double longitude
		{
			get
			{
				return this._longitude;
			}
			set
			{
				if ((this._longitude != value))
				{
					this.OnlongitudeChanging(value);
					this.SendPropertyChanging();
					this._longitude = value;
					this.SendPropertyChanged("longitude");
					this.OnlongitudeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ranking", DbType="NVarChar(17) NOT NULL", CanBeNull=false)]
		public string ranking
		{
			get
			{
				return this._ranking;
			}
			set
			{
				if ((this._ranking != value))
				{
					this.OnrankingChanging(value);
					this.SendPropertyChanging();
					this._ranking = value;
					this.SendPropertyChanged("ranking");
					this.OnrankingChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_imagem_de_perfil", DbType="VarBinary(MAX)", CanBeNull=true, UpdateCheck=UpdateCheck.Never)]
		public System.Data.Linq.Binary imagem_de_perfil
		{
			get
			{
				return this._imagem_de_perfil;
			}
			set
			{
				if ((this._imagem_de_perfil != value))
				{
					this.Onimagem_de_perfilChanging(value);
					this.SendPropertyChanging();
					this._imagem_de_perfil = value;
					this.SendPropertyChanged("imagem_de_perfil");
					this.Onimagem_de_perfilChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_pontuacao_geral", DbType="Int NOT NULL")]
		public int pontuacao_geral
		{
			get
			{
				return this._pontuacao_geral;
			}
			set
			{
				if ((this._pontuacao_geral != value))
				{
					this.Onpontuacao_geralChanging(value);
					this.SendPropertyChanging();
					this._pontuacao_geral = value;
					this.SendPropertyChanged("pontuacao_geral");
					this.Onpontuacao_geralChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_logged_in", DbType="Bit NOT NULL")]
		public bool logged_in
		{
			get
			{
				return this._logged_in;
			}
			set
			{
				if ((this._logged_in != value))
				{
					this.Onlogged_inChanging(value);
					this.SendPropertyChanging();
					this._logged_in = value;
					this.SendPropertyChanged("logged_in");
					this.Onlogged_inChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Utilizador_Utilizador_Ponto", Storage="_Utilizador_Pontos", ThisKey="email", OtherKey="Utilizadoremail")]
		public EntitySet<Utilizador_Ponto> Utilizador_Pontos
		{
			get
			{
				return this._Utilizador_Pontos;
			}
			set
			{
				this._Utilizador_Pontos.Assign(value);
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Utilizador_Sessao", Storage="_Sessaos", ThisKey="email", OtherKey="Utilizadoremail")]
		public EntitySet<Sessao> Sessaos
		{
			get
			{
				return this._Sessaos;
			}
			set
			{
				this._Sessaos.Assign(value);
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
		
		private void attach_Utilizador_Pontos(Utilizador_Ponto entity)
		{
			this.SendPropertyChanging();
			entity.Utilizador = this;
		}
		
		private void detach_Utilizador_Pontos(Utilizador_Ponto entity)
		{
			this.SendPropertyChanging();
			entity.Utilizador = null;
		}
		
		private void attach_Sessaos(Sessao entity)
		{
			this.SendPropertyChanging();
			entity.Utilizador = this;
		}
		
		private void detach_Sessaos(Sessao entity)
		{
			this.SendPropertyChanging();
			entity.Utilizador = null;
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.Sessao")]
	public partial class Sessao : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private string _codigo;
		
		private int _pontuacao;
		
		private System.Nullable<System.DateTime> _data;
		
		private System.Data.Linq.Binary _registo_de_voz;
		
		private string _relatorio;
		
		private string _Utilizadoremail;
		
		private double _distancia;
		
		private EntitySet<Ponto_Sessao> _Ponto_Sessaos;
		
		private EntityRef<Utilizador> _Utilizador;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OncodigoChanging(string value);
    partial void OncodigoChanged();
    partial void OnpontuacaoChanging(int value);
    partial void OnpontuacaoChanged();
    partial void OndataChanging(System.Nullable<System.DateTime> value);
    partial void OndataChanged();
    partial void Onregisto_de_vozChanging(System.Data.Linq.Binary value);
    partial void Onregisto_de_vozChanged();
    partial void OnrelatorioChanging(string value);
    partial void OnrelatorioChanged();
    partial void OnUtilizadoremailChanging(string value);
    partial void OnUtilizadoremailChanged();
    partial void OndistanciaChanging(double value);
    partial void OndistanciaChanged();
    #endregion
		
		public Sessao()
		{
			this._Ponto_Sessaos = new EntitySet<Ponto_Sessao>(new Action<Ponto_Sessao>(this.attach_Ponto_Sessaos), new Action<Ponto_Sessao>(this.detach_Ponto_Sessaos));
			this._Utilizador = default(EntityRef<Utilizador>);
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_codigo", DbType="NVarChar(11) NOT NULL", CanBeNull=false, IsPrimaryKey=true)]
		public string codigo
		{
			get
			{
				return this._codigo;
			}
			set
			{
				if ((this._codigo != value))
				{
					this.OncodigoChanging(value);
					this.SendPropertyChanging();
					this._codigo = value;
					this.SendPropertyChanged("codigo");
					this.OncodigoChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_pontuacao", DbType="Int NOT NULL")]
		public int pontuacao
		{
			get
			{
				return this._pontuacao;
			}
			set
			{
				if ((this._pontuacao != value))
				{
					this.OnpontuacaoChanging(value);
					this.SendPropertyChanging();
					this._pontuacao = value;
					this.SendPropertyChanged("pontuacao");
					this.OnpontuacaoChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_data", DbType="Date")]
		public System.Nullable<System.DateTime> data
		{
			get
			{
				return this._data;
			}
			set
			{
				if ((this._data != value))
				{
					this.OndataChanging(value);
					this.SendPropertyChanging();
					this._data = value;
					this.SendPropertyChanged("data");
					this.OndataChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_registo_de_voz", DbType="VarBinary(MAX)", CanBeNull=true, UpdateCheck=UpdateCheck.Never)]
		public System.Data.Linq.Binary registo_de_voz
		{
			get
			{
				return this._registo_de_voz;
			}
			set
			{
				if ((this._registo_de_voz != value))
				{
					this.Onregisto_de_vozChanging(value);
					this.SendPropertyChanging();
					this._registo_de_voz = value;
					this.SendPropertyChanged("registo_de_voz");
					this.Onregisto_de_vozChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_relatorio", DbType="NVarChar(MAX) NOT NULL", CanBeNull=false)]
		public string relatorio
		{
			get
			{
				return this._relatorio;
			}
			set
			{
				if ((this._relatorio != value))
				{
					this.OnrelatorioChanging(value);
					this.SendPropertyChanging();
					this._relatorio = value;
					this.SendPropertyChanged("relatorio");
					this.OnrelatorioChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Utilizadoremail", DbType="NVarChar(50) NOT NULL", CanBeNull=false)]
		public string Utilizadoremail
		{
			get
			{
				return this._Utilizadoremail;
			}
			set
			{
				if ((this._Utilizadoremail != value))
				{
					if (this._Utilizador.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnUtilizadoremailChanging(value);
					this.SendPropertyChanging();
					this._Utilizadoremail = value;
					this.SendPropertyChanged("Utilizadoremail");
					this.OnUtilizadoremailChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_distancia", DbType="Float NOT NULL")]
		public double distancia
		{
			get
			{
				return this._distancia;
			}
			set
			{
				if ((this._distancia != value))
				{
					this.OndistanciaChanging(value);
					this.SendPropertyChanging();
					this._distancia = value;
					this.SendPropertyChanged("distancia");
					this.OndistanciaChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Sessao_Ponto_Sessao", Storage="_Ponto_Sessaos", ThisKey="codigo", OtherKey="Sessaocodigo")]
		public EntitySet<Ponto_Sessao> Ponto_Sessaos
		{
			get
			{
				return this._Ponto_Sessaos;
			}
			set
			{
				this._Ponto_Sessaos.Assign(value);
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Utilizador_Sessao", Storage="_Utilizador", ThisKey="Utilizadoremail", OtherKey="email", IsForeignKey=true)]
		public Utilizador Utilizador
		{
			get
			{
				return this._Utilizador.Entity;
			}
			set
			{
				Utilizador previousValue = this._Utilizador.Entity;
				if (((previousValue != value) 
							|| (this._Utilizador.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._Utilizador.Entity = null;
						previousValue.Sessaos.Remove(this);
					}
					this._Utilizador.Entity = value;
					if ((value != null))
					{
						value.Sessaos.Add(this);
						this._Utilizadoremail = value.email;
					}
					else
					{
						this._Utilizadoremail = default(string);
					}
					this.SendPropertyChanged("Utilizador");
				}
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
		
		private void attach_Ponto_Sessaos(Ponto_Sessao entity)
		{
			this.SendPropertyChanging();
			entity.Sessao = this;
		}
		
		private void detach_Ponto_Sessaos(Ponto_Sessao entity)
		{
			this.SendPropertyChanging();
			entity.Sessao = null;
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.Ponto_Sessao")]
	public partial class Ponto_Sessao : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private double _Pontolatitude;
		
		private double _Pontolongitude;
		
		private string _Sessaocodigo;
		
		private System.Nullable<int> _ordem;
		
		private EntityRef<Sessao> _Sessao;
		
		private EntityRef<Ponto> _Ponto;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnPontolatitudeChanging(double value);
    partial void OnPontolatitudeChanged();
    partial void OnPontolongitudeChanging(double value);
    partial void OnPontolongitudeChanged();
    partial void OnSessaocodigoChanging(string value);
    partial void OnSessaocodigoChanged();
    partial void OnordemChanging(System.Nullable<int> value);
    partial void OnordemChanged();
    #endregion
		
		public Ponto_Sessao()
		{
			this._Sessao = default(EntityRef<Sessao>);
			this._Ponto = default(EntityRef<Ponto>);
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Pontolatitude", DbType="Float NOT NULL", IsPrimaryKey=true)]
		public double Pontolatitude
		{
			get
			{
				return this._Pontolatitude;
			}
			set
			{
				if ((this._Pontolatitude != value))
				{
					if (this._Ponto.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnPontolatitudeChanging(value);
					this.SendPropertyChanging();
					this._Pontolatitude = value;
					this.SendPropertyChanged("Pontolatitude");
					this.OnPontolatitudeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Pontolongitude", DbType="Float NOT NULL", IsPrimaryKey=true)]
		public double Pontolongitude
		{
			get
			{
				return this._Pontolongitude;
			}
			set
			{
				if ((this._Pontolongitude != value))
				{
					if (this._Ponto.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnPontolongitudeChanging(value);
					this.SendPropertyChanging();
					this._Pontolongitude = value;
					this.SendPropertyChanged("Pontolongitude");
					this.OnPontolongitudeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Sessaocodigo", DbType="NVarChar(11) NOT NULL", CanBeNull=false, IsPrimaryKey=true)]
		public string Sessaocodigo
		{
			get
			{
				return this._Sessaocodigo;
			}
			set
			{
				if ((this._Sessaocodigo != value))
				{
					if (this._Sessao.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnSessaocodigoChanging(value);
					this.SendPropertyChanging();
					this._Sessaocodigo = value;
					this.SendPropertyChanged("Sessaocodigo");
					this.OnSessaocodigoChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ordem", DbType="Int")]
		public System.Nullable<int> ordem
		{
			get
			{
				return this._ordem;
			}
			set
			{
				if ((this._ordem != value))
				{
					this.OnordemChanging(value);
					this.SendPropertyChanging();
					this._ordem = value;
					this.SendPropertyChanged("ordem");
					this.OnordemChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Sessao_Ponto_Sessao", Storage="_Sessao", ThisKey="Sessaocodigo", OtherKey="codigo", IsForeignKey=true)]
		public Sessao Sessao
		{
			get
			{
				return this._Sessao.Entity;
			}
			set
			{
				Sessao previousValue = this._Sessao.Entity;
				if (((previousValue != value) 
							|| (this._Sessao.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._Sessao.Entity = null;
						previousValue.Ponto_Sessaos.Remove(this);
					}
					this._Sessao.Entity = value;
					if ((value != null))
					{
						value.Ponto_Sessaos.Add(this);
						this._Sessaocodigo = value.codigo;
					}
					else
					{
						this._Sessaocodigo = default(string);
					}
					this.SendPropertyChanged("Sessao");
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Ponto_Ponto_Sessao", Storage="_Ponto", ThisKey="Pontolatitude,Pontolongitude", OtherKey="latitude,longitude", IsForeignKey=true)]
		public Ponto Ponto
		{
			get
			{
				return this._Ponto.Entity;
			}
			set
			{
				Ponto previousValue = this._Ponto.Entity;
				if (((previousValue != value) 
							|| (this._Ponto.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._Ponto.Entity = null;
						previousValue.Ponto_Sessaos.Remove(this);
					}
					this._Ponto.Entity = value;
					if ((value != null))
					{
						value.Ponto_Sessaos.Add(this);
						this._Pontolatitude = value.latitude;
						this._Pontolongitude = value.longitude;
					}
					else
					{
						this._Pontolatitude = default(double);
						this._Pontolongitude = default(double);
					}
					this.SendPropertyChanged("Ponto");
				}
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.Foto")]
	public partial class Foto : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private int _id;
		
		private string _email;
		
		private double _latitude;
		
		private double _longitude;
		
		private System.Data.Linq.Binary _foto1;
		
		private EntityRef<Utilizador_Ponto> _Utilizador_Ponto;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnidChanging(int value);
    partial void OnidChanged();
    partial void OnemailChanging(string value);
    partial void OnemailChanged();
    partial void OnlatitudeChanging(double value);
    partial void OnlatitudeChanged();
    partial void OnlongitudeChanging(double value);
    partial void OnlongitudeChanged();
    partial void Onfoto1Changing(System.Data.Linq.Binary value);
    partial void Onfoto1Changed();
    #endregion
		
		public Foto()
		{
			this._Utilizador_Ponto = default(EntityRef<Utilizador_Ponto>);
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_id", AutoSync=AutoSync.OnInsert, DbType="Int NOT NULL IDENTITY", IsPrimaryKey=true, IsDbGenerated=true)]
		public int id
		{
			get
			{
				return this._id;
			}
			set
			{
				if ((this._id != value))
				{
					this.OnidChanging(value);
					this.SendPropertyChanging();
					this._id = value;
					this.SendPropertyChanged("id");
					this.OnidChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_email", DbType="NVarChar(50) NOT NULL", CanBeNull=false)]
		public string email
		{
			get
			{
				return this._email;
			}
			set
			{
				if ((this._email != value))
				{
					if (this._Utilizador_Ponto.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnemailChanging(value);
					this.SendPropertyChanging();
					this._email = value;
					this.SendPropertyChanged("email");
					this.OnemailChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_latitude", DbType="Float NOT NULL")]
		public double latitude
		{
			get
			{
				return this._latitude;
			}
			set
			{
				if ((this._latitude != value))
				{
					if (this._Utilizador_Ponto.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnlatitudeChanging(value);
					this.SendPropertyChanging();
					this._latitude = value;
					this.SendPropertyChanged("latitude");
					this.OnlatitudeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_longitude", DbType="Float NOT NULL")]
		public double longitude
		{
			get
			{
				return this._longitude;
			}
			set
			{
				if ((this._longitude != value))
				{
					if (this._Utilizador_Ponto.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnlongitudeChanging(value);
					this.SendPropertyChanging();
					this._longitude = value;
					this.SendPropertyChanged("longitude");
					this.OnlongitudeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Name="foto", Storage="_foto1", DbType="VarBinary(MAX) NOT NULL", CanBeNull=false, UpdateCheck=UpdateCheck.Never)]
		public System.Data.Linq.Binary foto1
		{
			get
			{
				return this._foto1;
			}
			set
			{
				if ((this._foto1 != value))
				{
					this.Onfoto1Changing(value);
					this.SendPropertyChanging();
					this._foto1 = value;
					this.SendPropertyChanged("foto1");
					this.Onfoto1Changed();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Utilizador_Ponto_Foto", Storage="_Utilizador_Ponto", ThisKey="email,latitude,longitude", OtherKey="Utilizadoremail,Pontolatitude,Pontolongitude", IsForeignKey=true)]
		public Utilizador_Ponto Utilizador_Ponto
		{
			get
			{
				return this._Utilizador_Ponto.Entity;
			}
			set
			{
				Utilizador_Ponto previousValue = this._Utilizador_Ponto.Entity;
				if (((previousValue != value) 
							|| (this._Utilizador_Ponto.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._Utilizador_Ponto.Entity = null;
						previousValue.Fotos.Remove(this);
					}
					this._Utilizador_Ponto.Entity = value;
					if ((value != null))
					{
						value.Fotos.Add(this);
						this._email = value.Utilizadoremail;
						this._latitude = value.Pontolatitude;
						this._longitude = value.Pontolongitude;
					}
					else
					{
						this._email = default(string);
						this._latitude = default(double);
						this._longitude = default(double);
					}
					this.SendPropertyChanged("Utilizador_Ponto");
				}
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.Ponto")]
	public partial class Ponto : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private double _latitude;
		
		private double _longitude;
		
		private EntitySet<Utilizador_Ponto> _Utilizador_Pontos;
		
		private EntitySet<Ponto_Sessao> _Ponto_Sessaos;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnlatitudeChanging(double value);
    partial void OnlatitudeChanged();
    partial void OnlongitudeChanging(double value);
    partial void OnlongitudeChanged();
    #endregion
		
		public Ponto()
		{
			this._Utilizador_Pontos = new EntitySet<Utilizador_Ponto>(new Action<Utilizador_Ponto>(this.attach_Utilizador_Pontos), new Action<Utilizador_Ponto>(this.detach_Utilizador_Pontos));
			this._Ponto_Sessaos = new EntitySet<Ponto_Sessao>(new Action<Ponto_Sessao>(this.attach_Ponto_Sessaos), new Action<Ponto_Sessao>(this.detach_Ponto_Sessaos));
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_latitude", DbType="Float NOT NULL", IsPrimaryKey=true)]
		public double latitude
		{
			get
			{
				return this._latitude;
			}
			set
			{
				if ((this._latitude != value))
				{
					this.OnlatitudeChanging(value);
					this.SendPropertyChanging();
					this._latitude = value;
					this.SendPropertyChanged("latitude");
					this.OnlatitudeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_longitude", DbType="Float NOT NULL", IsPrimaryKey=true)]
		public double longitude
		{
			get
			{
				return this._longitude;
			}
			set
			{
				if ((this._longitude != value))
				{
					this.OnlongitudeChanging(value);
					this.SendPropertyChanging();
					this._longitude = value;
					this.SendPropertyChanged("longitude");
					this.OnlongitudeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Ponto_Utilizador_Ponto", Storage="_Utilizador_Pontos", ThisKey="latitude,longitude", OtherKey="Pontolatitude,Pontolongitude")]
		public EntitySet<Utilizador_Ponto> Utilizador_Pontos
		{
			get
			{
				return this._Utilizador_Pontos;
			}
			set
			{
				this._Utilizador_Pontos.Assign(value);
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Ponto_Ponto_Sessao", Storage="_Ponto_Sessaos", ThisKey="latitude,longitude", OtherKey="Pontolatitude,Pontolongitude")]
		public EntitySet<Ponto_Sessao> Ponto_Sessaos
		{
			get
			{
				return this._Ponto_Sessaos;
			}
			set
			{
				this._Ponto_Sessaos.Assign(value);
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
		
		private void attach_Utilizador_Pontos(Utilizador_Ponto entity)
		{
			this.SendPropertyChanging();
			entity.Ponto = this;
		}
		
		private void detach_Utilizador_Pontos(Utilizador_Ponto entity)
		{
			this.SendPropertyChanging();
			entity.Ponto = null;
		}
		
		private void attach_Ponto_Sessaos(Ponto_Sessao entity)
		{
			this.SendPropertyChanging();
			entity.Ponto = this;
		}
		
		private void detach_Ponto_Sessaos(Ponto_Sessao entity)
		{
			this.SendPropertyChanging();
			entity.Ponto = null;
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.melhor_explorador")]
	public partial class melhor_explorador
	{
		
		private string _Utilizadoremail;
		
		public melhor_explorador()
		{
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Utilizadoremail", DbType="NVarChar(50) NOT NULL", CanBeNull=false)]
		public string Utilizadoremail
		{
			get
			{
				return this._Utilizadoremail;
			}
			set
			{
				if ((this._Utilizadoremail != value))
				{
					this._Utilizadoremail = value;
				}
			}
		}
	}
	
	public partial class fotos_localResult
	{
		
		private System.Data.Linq.Binary _Foto;
		
		public fotos_localResult()
		{
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Foto", DbType="VarBinary(MAX) NOT NULL", CanBeNull=false)]
		public System.Data.Linq.Binary Foto
		{
			get
			{
				return this._Foto;
			}
			set
			{
				if ((this._Foto != value))
				{
					this._Foto = value;
				}
			}
		}
	}
	
	public partial class local_mais_visitadoResult
	{
		
		private double _Latitude;
		
		private double _Longitude;
		
		private System.Nullable<int> _Visitas;
		
		public local_mais_visitadoResult()
		{
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Latitude", DbType="Float NOT NULL")]
		public double Latitude
		{
			get
			{
				return this._Latitude;
			}
			set
			{
				if ((this._Latitude != value))
				{
					this._Latitude = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Longitude", DbType="Float NOT NULL")]
		public double Longitude
		{
			get
			{
				return this._Longitude;
			}
			set
			{
				if ((this._Longitude != value))
				{
					this._Longitude = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Visitas", DbType="Int")]
		public System.Nullable<int> Visitas
		{
			get
			{
				return this._Visitas;
			}
			set
			{
				if ((this._Visitas != value))
				{
					this._Visitas = value;
				}
			}
		}
	}
	
	public partial class quadro_pontuacoesResult
	{
		
		private System.Nullable<long> _Posicao;
		
		private string _Email;
		
		private int _Pontos;
		
		private string _Rank;
		
		public quadro_pontuacoesResult()
		{
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Posicao", DbType="BigInt")]
		public System.Nullable<long> Posicao
		{
			get
			{
				return this._Posicao;
			}
			set
			{
				if ((this._Posicao != value))
				{
					this._Posicao = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Email", DbType="NVarChar(50) NOT NULL", CanBeNull=false)]
		public string Email
		{
			get
			{
				return this._Email;
			}
			set
			{
				if ((this._Email != value))
				{
					this._Email = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Pontos", DbType="Int NOT NULL")]
		public int Pontos
		{
			get
			{
				return this._Pontos;
			}
			set
			{
				if ((this._Pontos != value))
				{
					this._Pontos = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Rank", DbType="NVarChar(17) NOT NULL", CanBeNull=false)]
		public string Rank
		{
			get
			{
				return this._Rank;
			}
			set
			{
				if ((this._Rank != value))
				{
					this._Rank = value;
				}
			}
		}
	}
	
	public partial class SplitResult
	{
		
		private int _Nr;
		
		private string _Item;
		
		public SplitResult()
		{
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Nr", AutoSync=AutoSync.Always, DbType="Int NOT NULL IDENTITY", IsDbGenerated=true)]
		public int Nr
		{
			get
			{
				return this._Nr;
			}
			set
			{
				if ((this._Nr != value))
				{
					this._Nr = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Item", DbType="NVarChar(MAX)")]
		public string Item
		{
			get
			{
				return this._Item;
			}
			set
			{
				if ((this._Item != value))
				{
					this._Item = value;
				}
			}
		}
	}
}
#pragma warning restore 1591
